# This file is placed in the Public Domain.


"object programming modules"


import threading
import time


from op import Object, get, keys, update


from op.bus import Bus
from op.command import Command
from op.parse import aliases, elapsed
from op.thread import getname, starttime


def __dir__():
    return (
        "commands",
        "fleet"
        "threads"
    )





def commands(event):
    event.reply(",".join((sorted(keys(Command.cmd)))))


cmd = commands

def fleet(event):
    try:
        index = int(event.args[0])
        event.reply(Bus.objs[index])
        return
    except (KeyError, TypeError, IndexError, ValueError):
        pass
    event.reply(" | ".join([getname(o) for o in Bus.objs]))


def threads(event):
    result = []
    for t in sorted(threading.enumerate(), key=lambda x: x.getName()):
        if str(t).startswith("<_"):
            continue
        o = Object()
        update(o, vars(t))
        if get(o, "sleep", None):
            up = o.sleep - int(time.time() - o.state.latest)
        else:
            up = int(time.time() - starttime)
        thrname = t.getName()
        if not thrname:
            continue
        if thrname:
            result.append((up, thrname))
    res = []
    for up, txt in sorted(result, key=lambda x: x[0]):
        res.append("%s(%s)" % (txt, elapsed(up)))
    if res:
        event.reply(" ".join(res))


Command.add(commands)
Command.add(fleet)
Command.add(threads)
aliases.cmd = "commands"
aliases.flt = "fleet"
aliases.thr = "threads"
